// Do not remove the include below
#include "EspThermometer2.h"
#include "defines.h"

// #define ESP8266


#include <EEPROM.h>

#include "configuration.h"
#include "productionMode.h"
#include "configurationMode.h"



ADC_MODE(ADC_VCC);








bool configMode = false;





uint32_t startTime = 0;


void setup() {
  startTime = millis();
#ifdef DEBUG
  Serial.begin(115200);
  Serial.println("Starting ...");
#endif

  pinMode(CONFIG_SWITCH, INPUT_PULLUP);
  pinMode(LED_PIN, OUTPUT);


  EEPROM.begin(512);
  for (uint16_t i = 0; i < sizeof(configBlock); i++) {
    char x = EEPROM.read(EEPROM_ADDR + i);
	Serial.print("read from eeprom: ");
	Serial.print(i);
	Serial.print(" ");
	Serial.print((uint8_t)x);
	Serial.print(" ");
	Serial.println(x);
	*(((char*)(&configBlock))+i) = x;
  }


  Serial.print("Magic: ");
  Serial.println(configBlock.magic);

  configMode = ((LOW == digitalRead(CONFIG_SWITCH)) || (configBlock.magic != MAGIC));

  if (configMode) {
#ifdef DEBUG
  Serial.println("Configuration mode");
#endif
  	digitalWrite(LED_PIN, HIGH);
    setupConfiguration();
  } else {
#ifdef DEBUG
  Serial.println("Production mode");
  Serial.println();
  Serial.println();
  showConfiguration();
#endif

	digitalWrite(LED_PIN, LOW);
    setupProduction();
  }

#ifdef DEBUG
  Serial.println("Started.");
#endif
}

void loop() {
  if (configMode) {
    loopConfiguration();
  } else {
    loopProduction();
  }
}


